static char *cvs_id =" $Id: txt_lib.c,v 1.3 2004/09/23 06:35:26 berar Exp $ ";
/*  edf_lib : txt data format  */
/*  jf berar */
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
/*-----------------------------------------------------------*/
#include "txt_def.h"
extern int   cr_mode;
/*-----------------------------------------------------------*/
XY_HDR   *txt_gethdr (FILE *f);    
void    txt_hdrfill( FILE *f, XY_HDR *h);
/*-----------------------------------------------------------*/
static long newseek = 0;
static long newrow = 0;
/*-----------------------------------------------------------*/
/* read edf file header and seek to its end                  */
#define BUF_LG 4096
XY_HDR *txt_gethdr( FILE *f )
{  char buffer[1+BUF_LG];
   char *c, *d;
   int r, n, v, nx = 0, nc = 0;
	int end = 0;
	XY_HDR  *h;
    
/*	buffer = malloc(BUF_LG+1);*/
	h = (XY_HDR *) malloc(sizeof(XY_HDR));
   memset(h, 0, sizeof(XY_HDR));
   h->t_data = T_ASCII;
	h->frames = 1;
   h->header_end = 0;
   do
	{  end = ftell(f);	
	   fgets(buffer, BUF_LG, f);
	   } while (buffer[0] == '#' );
   c = buffer;
/* printf("== buffer = %s", buffer); */
	do
	{  n = 0;
	   r = sscanf(c,"%d%n", &v, &n);
		if (r == 1) 
		{  c +=n;
		   nc += n;
			nx++;
			}
		} while (r == 1);
    h->x_dim = nx; 
	 if ( nc >= BUF_LG )
	 {   fprintf(stderr,"Too many chars in lines, txt_lib is limited to %d chars", BUF_LG);
	     }
   n=1;
	while (!feof(f) && buffer[0] != '#')
	{  fgets(buffer, BUF_LG, f);
	   if (buffer[0] && buffer[0] != '#') n++;
      if ( feof(f) ) printf("feof =%d=\n", n); 
      if ( buffer[0] == '#' ) printf("'#' =%d= buffer = %s", n, buffer); 
		} 
    h->y_dim = n-1; 
    h->header_end = end;
	 newseek = end;
/*    free (buffer);*/
	 return h;    
    }
/*-----------------------------------------------------------*/
void    txt_hdrfill( FILE *f, XY_HDR *h)
{   INT16U  val, valt, valh, valm;
    INT32   val32;
    float   valf;
    char *c, t[12], buffer[BUF_LG+1];

    h->edf_disp = h->edf_used = 0;
    xy_edfstr( h, "HeaderID", "EH:000001:000000:000000");
    xy_edfstr( h, "ByteOrder", "LowByteFirst");
    xy_edfstr( h, "DataType", "SignedInt" );
    sprintf(buffer,"%hd", h->x_dim);
    xy_edfstr(h, "Dim_1", buffer);
    sprintf(buffer,"%hd", h->y_dim);
    xy_edfstr(h, "Dim_2", buffer);
    sprintf(buffer,"%d", h->frames);
    xy_edfstr(h, "Image", buffer);
   
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
XY_HDR  *txt_fopen (FILE *f, int quick, char * buffer)
{   XY_HDR *h;
    h = txt_gethdr( f );
    if (h->t_data != T_INT16U || quick == 0 )
    {    txt_hdrfill(f , h);
         }
    h->name = str_alloc(buffer);
	 h->xy_mode = TXT_XYMODE;
    h->file = f;
    return h;
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/* for direct compatibility with wv2ph, direct acces function 
/* recupere une image depuis la position courante du fichier */
/* XMIN ....non traite */
int txt_getraw(XY_HDR *h, IMAGE *img, void *val, int pos)
{   int  i, j, k, xread, xseek, xfor, yfor, size;
    long   p;
    INT32    *vl;
    size = sizeof(INT32); 
    xfor=img->x_tsize;
    yfor=img->y_tsize;
    p = img->header->header_end;
printf("  %d %d \n",img->x_tsize, img->y_tsize);
    for ( k=0; k<yfor; k++ )
    {   vl = (INT32 *) val + k * xfor;
	     /*   fseek( h->file, p, 0);  */
       for ( j =0; j<img->x_tsize; j++, vl++ )
		 {  if ( fscanf(h->file,"%d", vl ) != 1)
          {   fprintf(stderr, "TXTGETRAW error %d reading %d image at y = %d, y_min %d, pos %d\n",
                  errno, j, k+img->y_omin, img->y_omin, pos);
              return -1;
				  }
           }
       }   
   return img->y_tsize;    
   }
/*-----------------------------------------------------------*/
int txt_getimg(XY_HDR *h, IMAGE *img, int pos)
{   INT16U *raw;
    float *rawf;
    int i;
   switch  (h->t_data)
   {  case T_INT16U :     
         raw = (INT16U *) malloc(img->osize * sizeof(INT16U));
         i = txt_getraw(h, img, raw, pos);
         xy16u_bind( img, raw);
         free(raw);
	 break;
      case T_FLOAT  : 
         rawf = (float *) malloc(img->osize * sizeof(float));
         i = txt_getraw(h, img, rawf, pos);
         xy32f_bind( img, rawf);
         free(rawf);
	 break;
      }
    img->name = h->name;
    return i;
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
extern char * prg_name;
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
void     txt_write  (IMAGE *img)
{   int i, j, k;
    char fname[256];
    INT32 * val = img->data.i;
    FLOAT64 * fval = img->data.f;
    int is_float = xy_isfloat(img);
    FILE *fout;
    
    strcpy(fname, img->name);
    if (strstr(fname, ".txt") == NULL) strcat(fname, ".txt");
    prg_printf(" %s\n", fname);
    fout = fopen(fname, "wb");
    if ( fout == NULL ) v_error(__FILE__, "unable to open the txt out file : %s\n", fname);
    if ( img->x_size <=  img->y_size )
	   for (j=0; j < img->y_size; j++)
      {  for (i=0, k=j*img->x_size; i < img->x_size; i++, k++) 
           if (is_float ) fprintf( fout, " %f", fval[k]);
           else           fprintf( fout, " %d", val[k]);
         fprintf( fout, "%c\n",cr_mode==0?' ':'\r');
         }
	 else
	   for (i=0; i < img->x_size; i++)
      {  for (j=0; j < img->y_size; j++) 
           if (is_float ) fprintf( fout, " %f", fval[k]);
           else           fprintf( fout, " %d", val[k]);
         fprintf( fout, "%c\n",cr_mode==0?' ':'\r');
         }
	 fclose (fout);
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/

